<?php
// Slider Plugin

// Image suffixes allowed
define('PLUGIN_REF_IMAGE', '/\.(gif|png|jpe?g|swf)$/i');

// Usage (a part of)
define('PLUGIN_REF_USAGE', "([pagename/]attached-file-name[,parameters, ... ][,title])");


function plugin_slider_convert(){

  $args = func_get_args();

  if( $args[0] == "left"){
    $layout="float:left; margin-right:1rem;";
  } else if( $args[0] == "center"){
    $layout="margin:0 auto;";
  } else if( $args[0] == "right"){
    $layout="float:right; margin-left:1rem;";
  } else {
    $layout="margin:0 auto;";
  }

  if( substr($args[1],-1,1) == "%"){
    $width = $args[1];
  } else {
    $width = "100%";
  }

  $fade = 'true'; //default
  $vertical = 'false'; //default
  $slidesToShow = 1;

  if( substr($args[2],0,1) == "h") {
    $fade = 'false';
    if( is_natural( substr($args[2],1,1) ) ) $slidesToShow = substr($args[2],1,1);
  }
  if( substr($args[2],0,1) == "v") {
    $fade = 'false';
    $vertical = 'true';
    if( is_natural( substr($args[2],1,1) ) ) $slidesToShow = substr($args[2],1,1);
  }

  if( is_numeric( $args[3] ) ){
    $autoplaySpeed = $args[3];
  } else {
    $autoplaySpeed = 3000;
  }

  if( is_numeric( $args[4] ) ){
    $speed = $args[4];
  } else {
    $speed = 2000;
  }

  $style='style="width:'.$width.'; '.$layout.'"';

  $params = plugin_slider_body(func_get_args());

  // Genetate ID
  $num = 8; // 文字数
  $ar1 = range('a', 'z'); // アルファベット小文字を配列に
  $ar2 = range('A', 'Z'); // アルファベット大文字を配列に
  $ar_all = array_merge($ar1, $ar2); // すべて結合
  shuffle($ar_all); // ランダム順にシャッフル
  $id = substr(implode($ar_all), 0, $num); // 先頭の8文字
  $idSelector = "#"."$id";

  // OUTPUT
  return <<<HTML
<script src="slick/slick.min.js"></script>
<script>
    $( function() {
      $( "$idSelector" ).slick({
        // アクセシビリティ。左右ボタンで画像の切り替えをできるかどうか
        accessibility: true,
        // 自動再生。trueで自動再生される。
        autoplay: true,
        // 自動再生で切り替えをする時間
        autoplaySpeed: $autoplaySpeed,
        // 自動再生や左右の矢印でスライドするスピード
        speed: $speed,
        // 自動再生時にスライドのエリアにマウスオンで一時停止するかどうか
        pauseOnHover: true,
        // 自動再生時にドットにマウスオンで一時停止するかどうか
        pauseOnDotsHover: true,
        // 切り替えのアニメーション。ease,linear,ease-in,ease-out,ease-in-out
        cssEase: 'ease',
        // 画像下のドット（ページ送り）を表示
        dots: false,
        // ドットのclass名をつける
        dotsClass: 'dot-class',
        // ドラッグができるかどうか
        draggable: true,
        // 切り替え時のフェードイン設定。trueでon
        fade: $fade,
        // 左右の次へ、前へボタンを表示するかどうか
        arrows: false,
        // 無限スクロールにするかどうか。最後の画像の次は最初の画像が表示される。
        infinite: true,
        // 最初のスライダーの位置
        initialSlide: 0,
        // 画像の遅延表示。‘ondemand’or'progressive'
        lazyLoad: 'progressive',
        // スライドのエリアにマウスオーバーしている間、自動再生を止めるかどうか。
        pauseOnHover: true,
        // スライドのエリアに画像がいくつ表示されるかを指定
        slidesToShow: $slidesToShow,
        // 一度にスライドする数
        slidesToScroll: 1,
        // タッチスワイプに対応するかどうか
        swipe: true,
        // 縦方向へのスライド
        vertical: $vertical,
        // 表示中の画像を中央へ
      　centerMode: true,
        // 中央のpadding
        centerPadding: '0px'
      });
    });
</script>

<link rel="stylesheet" href="slick/slick.css">
<link rel="stylesheet" href="slick/slick-theme.css">
<style type="text/css">
    /*
    .slider {
      width: $width;
      margin: 0 auto;
    }
    */
    .slick-slide {
      margin: 0px 0px;
    }
    .slick-slide img {
      width: 100%;
    }
    .slick-prev {
      left: 5%;
      z-index: 99;
    }
    .slick-next {
      right: 5%;
      z-index: 99;
    }
    .slick-prev:before,
    .slick-next:before {
      color: rgba(255,255,255,0.5);
    }
    /*
    .slick-slide {
      transition: all ease-in-out .3s;
      opacity: .2;
    }
    .slick-active {
      opacity: .5;
    }
    .slick-current {
      opacity: 1;
    }
    */
  </style>

<div id="$id" class="slider" $style>{$params['_body']}
</div>
HTML;
}


function plugin_slider_body($args) {

  global $script, $vars;

  // 出力されるHTML
  $params['_body'] ='';

  // 要素数をカウント
  $count = count($args);

  for($i=5; $i<$count; $i++){

    // 添付ファイルのファイル名
    $name = $args[$i];

    // 添付ファイルまでのパスおよび(実際の)ファイル名
    $file = '';

    $matches = array();
    // ファイル名にページ名(ページ参照パス)が合成されているか
    //   (Page_name/maybe-separated-with/slashes/ATTACHED_FILENAME)
    if (preg_match('#^(.+)/([^/]+)$#', $name, $matches)) {
      if ($matches[1] == '.' || $matches[1] == '..') {
        $matches[1] .= '/'; // Restore relative paths
      }
      $name = $matches[2];
      $page = get_fullname(strip_bracket($matches[1]), $page); // strip is a compat
      $file = UPLOAD_DIR . encode($page) . '_' . encode($name);
    } else {
      $page = $vars['page'];
      $file = UPLOAD_DIR . encode($page) . '_' . encode($name);
    }

    $title = htmlsc($name);
    $url = $script . '?plugin=slider' . '&' . 'page=' . rawurlencode($page) .
            '&' . 'src=' . rawurlencode($name); // Show its filename at the last
    /*
    $size = @getimagesize($file);
    $width  = $size[0];
    $height = $size[1];
*/
    $params['_body'] = $params['_body'] . "<img src=\"$url\" alt=\"$title\" title=\"$title\" $info/>";

  }

  return $params;
}


// Output an image (fast, non-logging <==> attach plugin)

function plugin_slider_action()
{
  global $vars;

  $page     = $vars['page'];
  $filename = $vars['src'] ;

  $slider = UPLOAD_DIR . encode($page) . '_' . encode(preg_replace('#^.*/#', '', $filename));

  if(! file_exists($slider))
    return array('msg'=>'Attach file not found', 'body'=>$usage);

  $is_image = preg_match(PLUGIN_REF_IMAGE, $filename);
  if (!$is_image) {
    return array('msg'=>'Seems not an image', 'body'=>$usage);
  }
  $got = @getimagesize($slider);
  if (! isset($got[2])) $got[2] = FALSE;
  switch ($got[2]) {
  case 1: $type = 'image/gif' ; break;
  case 2: $type = 'image/jpeg'; break;
  case 3: $type = 'image/png' ; break;
  case 4: $type = 'application/x-shockwave-flash'; break;
  default:
    return array('msg'=>'Seems not an image', 'body'=>$usage);
  }

  // Care for Japanese-character-included file name
  $legacy_filename = mb_convert_encoding($filename, 'UTF-8', SOURCE_ENCODING);
  if (LANG == 'ja') {
    switch(UA_NAME . '/' . UA_PROFILE){
    case 'MSIE/default':
      $legacy_filename = mb_convert_encoding($filename, 'SJIS', SOURCE_ENCODING);
      break;
    }
  }
  $utf8filename = mb_convert_encoding($filename, 'UTF-8', SOURCE_ENCODING);
  $size = filesize($slider);

  // Output
  pkwk_common_headers();
  header('Content-Disposition: inline; filename="' . $legacy_filename
    .'"; filename*=utf-8\'\'' . rawurlencode($utf8filename));
  header('Content-Length: ' . $size);
  header('Content-Type: '   . $type);
  @readfile($slider);
  exit;
}

function is_natural($val) {
    return (bool) preg_match('/\A[1-9][0-9]*\z/', $val);
}
